%{
#include<stdio.h>
extern int lexinit(FILE*);
extern int yylex();
extern int yyerror(char*);
%}

%token V C F L N 

%left L 
%left N 

%%

s : a 
  { 
    printf("R(a.)\n"); 
  }
  | a 
    s
  { 
    printf("R(as.)\n"); 
  }
  ;
a : V 
  '=' 
  e 
  ';' 
  { 
    printf("R(V=e;.)\n"); 
  }
  ;
e : e 
    L 
    e
  { 
    printf("R(eLe.)\n"); 
  }
  | e 
    N 
    e
  { 
    printf("R(eNe.)\n"); 
  }
  | F 
    '(' 
    e 
    ')'
  { 
    printf("R(F(e).)\n"); 
  }
  | V
  { 
    printf("R(V.)\n"); 
  }
  | C
  { 
    printf("R(C.)\n"); 
  }
  ;

%%

int yyerror(char *msg) { printf("ERROR: %s \n",msg); return -1; }

int main(int argc,char** argv)
{
  FILE *source_file=fopen(argv[1],"r");
  lexinit(source_file); 
  yyparse();
  fclose(source_file);
  return 0;
}

